# Spark-AR-PFTools
Some utilities and library for Spark AR. Most of them are **Script Only** tools currently.

## Repository with Demo Projects
Some tools are migrated to be individual packages.
- PFTween -> [sparkar-pftween](https://github.com/pofulu/sparkar-pftween): A wrapped Spark AR animation tool
- PFScreen -> [sparkar-screen](https://github.com/pofulu/sparkar-screen): Convert coordinate and positioning object.

And others are not be included in this repo.
- [sparkar-particle](https://github.com/pofulu/sparkar-particle): A wrapped tool for controlling emitters
- [sparkar-picker-handler](https://github.com/pofulu/sparkar-picker-handler): A wrapper of NativeUI.picker
- [sparkar-smoother](https://github.com/pofulu/sparkar-smoother): Make object smoothly follow facial features with object's naming.
- [sparkar-transfer](https://github.com/pofulu/sparkar-transfer): Send any object's transform value to Patch Editor.
- [sparkar-autofit](https://github.com/pofulu/sparkar-autofit): Keeping the texture of object in correct ratio.
- [sparkar-cloner](https://github.com/pofulu/sparkar-cloner): Dynamically instantiating blocks and controlling them without coding.
- [sparkar-bezier-easing](https://github.com/pofulu/sparkar-bezier-easing): cubic-bezier implementation for Spark AR animation easings.
- [sparkar-logger](https://github.com/pofulu/sparkar-logger): Simple runtime console logger for Spark AR

## `npm` Only
There are some tool are published only in `npm` currently. These tools are not included any sample project, but could be useful in develope. Please note that these could be more buggly then above tools, some of them even don't have a proper README😅
- [sparkar-scenequery](https://www.npmjs.com/package/sparkar-scenequery): Bunch of functions to filter scene objects
- [sparkar-invoke](https://www.npmjs.com/package/sparkar-invoke): An utility to help handling EventSource
- [sparkar-animator](https://www.npmjs.com/package/sparkar-animator): A library to control models animation by keyframes
- [sparkar-sound](https://www.npmjs.com/package/sparkar-sound): Simple tool to control audio with script
- [sparkar-device](https://www.npmjs.com/package/sparkar-device): A tool to accessing to display information
- [sparkar-remap](https://www.npmjs.com/package/sparkar-remap): An Utility for mapping value
- [sparkar-bundler](https://github.com/pofulu/sparkar-bundler): TypeScript bundler for transpiling package to Meta Spark Studio

## Donations
If these are useful for you, please consider a donation🙏🏼. One-time donations can be made with PayPal.

[![](https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=HW99ESSALJZ36)
